/*
    ifinf - A utility for retreiving network interface status/ip.
    Copyright (C) 1999 Rok Papez

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    A copy of license should be in ../LICENSE/GPL2.TXT
*/

#include <stdio.h>
#include <string.h>
#include "iflib.h"

int help(char *prog) {
  printf("Usage:\n %s up|ip interface\nExample:\n %s ip ppp0\n",prog,prog);
  return(-2);
}

int main(int argc, char *argv[]) {
  char ip[16];
  if (argc<2)
    return help(argv[0]);

  if (!strcmp(argv[1],"ip")) {
    printf("%s\n",iflibIp2String(iflibGetIp(argv[2]),ip));
    return(0);
  } else if (!strcmp(argv[1],"up")) {
    return(iflibIsUp(argv[2]));
  } else {
    return help(argv[0]);
  }
}

