/*
    iflib - a library for retreiving network interface information
    Copyright (C) 1999 Rok Papez.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

    A copy of license should be in ../LICENSE/LGPL2.TXT
*/
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include "iflib.h"

// private members!
inline void charSeg(int i_ip,char **pch_ip);


//-------------------------------------------------
// return: !0  - error          0 - success
// This code is a MESS!!! just about as big as /proc/net/dev :p itself.
// Issuse.. if this realy is the only way how to get that data, wtf didn't the momo
// that defined the fromat did it in easy machine processable way.
// SHEEESH!!!

// We presume that the first char is IN the ch for every segment of this function.
int iflibStatIf(char *name,unsigned long *Rx,unsigned long *RxErr,unsigned long *Tx,unsigned long *TxErr) {
  FILE *fd;
  int rc=0;
  int ch;
  int spaces;
  int packets,errs,i;
  signed int mode;
  char *str[2]={"packets","errs"};

  Rx[0]=0;
  RxErr[0]=0;
  Tx[0]=0;
  TxErr[0]=0;

  fd=fopen("/proc/net/dev","rb"); // proc fs, I/O is lightning fast compared to disk - I hope ;)
  if (!fd)
    return(1);

  ch=fgetc(fd); 

  // skip first line
  for(;ch!=EOF && ch!='\n';ch=fgetc(fd));
  ch=fgetc(fd); // pick up a char after '\n'
  if(EOF==ch) {
    rc=1;
    goto stat_exit;
  }

  // count the spaces and get the cols for packets and err :p .. this suxx
  spaces=mode=i=packets=errs=0; // mode&0x03  x0x | x1x | x3x         -- 0x04 is set if one space was already picked up.
  for(;ch!=EOF && ch!='\n';ch=fgetc(fd)) {
    switch(ch) {
    case '|':
        if (!(mode&0x03))
          mode|=0x01|0x04; // fake a space (start)
        else if(1==(mode&0x03))
          mode|=0x02;
        break;

    case ' ':
        if (1==(mode&0x03))
        if (!(mode&0x04)) {
          mode|=0x04;
          spaces++;
        }
        break;

    default:
        if (1==(mode&0x03)) {
          if (ch==(str[0])[i] && !packets && ((i && mode&0x08) || (!i && mode&0x04))) {
            mode|=0x08;
            i++;
            if (!(str[0])[i]) {
              i=0;
              packets=spaces;
              mode&=~0x08;
            }
          }
          else if (ch==(str[1])[i] && !errs && ((i && mode&0x10) || (!i && mode&0x04))) {
            if (!i) mode|=0x10;
            i++;
            if (!(str[1])[i]) {
              i=0;
              errs=spaces;
              mode&=~0x10;
            }
          }
        }
        mode&=~0x04;
    }
  }
  ch=fgetc(fd); // pick up a char after '\n'
  if(EOF==ch) {
    rc=2;
    goto stat_exit;
  }
  // now we have to find the matching interface and output the cols:
  // mode==0 : mode  0x01 -> behind ':' mode 0x04 -> the ' ' flag, mode 0x02 -> match
  // packets, errs, spaces+packets+2, spaces+errs+2
  i=0;
  mode=0x02;
  for(;ch!=EOF;ch=fgetc(fd)) {
    if (ch=='\n') { // newline
      i=0;
      mode=0x02;
      continue;
    }
    //match the iFace
    if (!(mode&0x01)) {
      switch(ch) {
      case ' ':
          i=0;
          break;

      case ':': // we have a match
          if (name[i])
            mode&=~0x02;
          mode|=0x01;
          i=0;
          // another big thanx to the momo that laid down the format of /proc/net/dev .. I mean.. does MACHINE PROCESSABLE RING A BIG FUCKING BELL!!!!!! ASSHOLE!!!!
          // Why does one HAVE to bve a ROCKET SCIENTIST to PARSE a fucking file in single-pass :p.
          for(;ch!=EOF && ch==' ';ch=fgetc(fd)); // ff
          // fake that we already received a space (thanx momo!)
          i=1;
          mode|=0x04;
          break;

      default:
          if (ch!=name[i])
            mode&=~0x02; // we don't have a match :p.
          else
            i++;
          break;
      }
      continue;
    }
    
    // we have a match -> process the cols
    if (3==(mode&0x03)) { // a match + behind ':'
      switch(ch) {
      case ' ':
          if (!(mode&0x04))
            i++; // i counts the cols
          mode|=0x04;
          break;

      default:   // catch the cols
          mode&=~0x04;
          if (i-1==packets) {
            if (defIsNum(ch)) Rx[0]=ch-'0'+Rx[0]*10;
          } else if(i-1==errs) {
            if (defIsNum(ch)) RxErr[0]=ch-'0'+RxErr[0]*10;
          } else if(i==packets+spaces+2) {
            if (defIsNum(ch)) Tx[0]=ch-'0'+Tx[0]*10;
          } else if(i==errs+spaces+2) {
            if (defIsNum(ch)) TxErr[0]=ch-'0'+TxErr[0]*10;
          }
          break;
          
      } //~switch
    } // ~if
  } //~for


stat_exit:
  fclose(fd);
  return(rc);
}
//-------------------------------------------------
void charSeg(int i_ip,char **pch_ip) {
  int zero=1;
  int fac;

  fac=i_ip/100;
  i_ip%=100;
  if(fac) {
    (*pch_ip)[0]='0'+fac;
    (*pch_ip)++;
    zero=0;
  }
  fac=i_ip/10;
  i_ip%=10;
  if(fac || !zero) {
    (*pch_ip)[0]='0'+fac;
    (*pch_ip)++;
  }
  (*pch_ip)[0]='0'+i_ip;
  (*pch_ip)++;
  (*pch_ip)[0]='.';
}

//-------------------------------------------------
// pch_ip in has 16bytes allocated to it.
char *iflibIp2String(int i_ip,char pch_ip[16]) {
  char *ch=pch_ip;
  int seg;

  i_ip=htonl(i_ip);
  seg=(i_ip&0xFF000000)>>24;
  charSeg(seg,&pch_ip);
  pch_ip++;

  seg=(i_ip&0xFF0000)>>16;
  charSeg(seg,&pch_ip);
  pch_ip++;
  
  seg=(i_ip&0xFF00)>>8;
  charSeg(seg,&pch_ip);
  pch_ip++;

  seg=i_ip&0xFF;
  charSeg(seg,&pch_ip);
  pch_ip[0]='\0';
  return(ch);
}
//-------------------------------------------------
int iflibGetIp(char *name)  {
  int sockfd;
  struct ifreq strIfReq;
  char *buf;

  strcpy(strIfReq.ifr_name,name);
  sockfd=socket(PF_INET,SOCK_STREAM,0);
  if (ioctl(sockfd,SIOCGIFADDR,&strIfReq))
    return(0);
  close(sockfd);
  return(((int*)(&strIfReq.ifr_addr))[1]);
}
//-------------------------------------------------
int iflibIsUp(char *name) {
  int sockfd;
  struct ifreq strIfReq;

  strcpy(strIfReq.ifr_name,name);
  sockfd=socket(PF_INET,SOCK_STREAM,0);
  if (ioctl(sockfd,SIOCGIFFLAGS,&strIfReq))
    return(-1);
  close(sockfd);
  if (strIfReq.ifr_flags&IFF_UP)
    return(1);
  return(0);
}
